/*
 *   Token management
 */

#include <stdio.h>
#include <string.h>
#include <strings.h>
#include "token.h"

struct token {
  char *name;
  int kind;
  char *type;
  char *pattern;
  struct token *next;
};

static struct token *tokens = 0;
static int token_counter = 0;

static char *new_token_name() {
  char buf[32];

  sprintf(buf, "TOKEN%d", token_counter++);
  return strdup(buf);
}

struct token *find_token_by_name(name) char *name; {
  struct token *p;

  for (p = tokens; p; p = p->next) 
    if (strcmp(name, p->name) == 0)
      return p;
  return 0;
}

struct token *find_token_by_pattern(pat) char *pat; {
  struct token *p;

  for (p = tokens; p; p = p->next) 
    if (strcmp(pat, p->pattern) == 0)
      return p;
  return 0;
}

char *pattern_to_token_name(pat) char *pat; {
  struct token *p = find_token_by_pattern(pat);
  if (!p)
    p = declare_token(new_token_name(), noType, 0, pat);
  return p->name;
}

char *token_name_to_token_type(name) char *name; {
  struct token *p = find_token_by_name(name);
  if (p)
    return p->type;
  else
    return 0;
}

struct token *declare_token(name, kind, type, pat) 
     int kind;
     char *name, *type, *pat; 
{
  extern FILE *ytok;
  struct token *p = (struct token *)malloc(sizeof(struct token));
  p->name = name;
  p->kind = kind;
  p->type = type;
  p->pattern = pat;
  p->next = tokens;
  tokens = p;
  fprintf(ytok, "%%token %s\n", name);
  return p;
}

char *token_action[] = {
  "",
  "yylval.i = atoi(yytext);",
  "yylval.f = atof(yytext);",
  "yylval.s = strdup(yytext);",
  "yylval.d = atof(yytext);"
};

char *regexp(pat) char *pat; {
  /*
  if (pat[0] == '/') {
    ++pat;
    pat[strlen(pat) - 1] = 0;
  }
  */
  return pat;
}

emit_token_lex_rules() {
  struct token *p;
  for (p = tokens; p; p = p->next) {
    fprintf(lrule, "%s\t{%sreturn %s;}\n", 
	    regexp(p->pattern), token_action[p->kind], p->name);
  }
}
